module Control.DeepSeq.ByteString
       ( -- Just for the instances
       ) where

import Control.DeepSeq (NFData(..))
import qualified Data.ByteString as BS
import qualified Data.ByteString.Lazy as BSL

-- Strict byte strings are already in WHNF.
instance NFData BS.ByteString

-- Conversion to strict chunks ensures WHNF.
instance NFData BSL.ByteString where
        rnf a = rnf (BSL.toChunks a)
